<?php

class iHomefinderFormData {
	
	private $initialized = false;
	private $hotSheets;
	private $cities; 
	private $cityZips; 
	private $propertyTypes;
	private $agents;
	private $offices;
	private static $instance;
	
	public static function getInstance() {
		if(!isset(self::$instance)) {
			self::$instance = new self();
		}
		return self::$instance;
	}
	
	private function initialize() {
		if(!$this->initialized) {
            $this->initialized = true;
			$remoteRequest = new iHomefinderRequestor();
			$remoteRequest
                ->addParameter("method", "handleRequest")
                ->addParameter("viewType", "json")
                ->addParameter("requestType", "search-form-lists")
			;
			$remoteResponse = $remoteRequest->remoteGetRequest();
			$response = $remoteResponse->getResponse();
			if(is_object($response)) {
				if(property_exists($response, "hotsheetsList")) {
					$this->hotSheets = $this->convertItemValues($response->hotsheetsList);
				}
				if(property_exists($response, "citiesList")) {
					$this->cities = $this->convertItemValues($response->citiesList);
				}
				if(property_exists($response, "cityZipList")) {
					$this->cityZips = $this->convertItemValues($response->cityZipList);
				}
				if(property_exists($response, "propertyTypesList")) {
					$this->propertyTypes = $this->convertItemValues($response->propertyTypesList);
				}
				if(property_exists($response, "agentList")) {
					$this->agents = $this->convertItemValues($response->agentList);
				}
				if(property_exists($response, "officeList")) {
					$this->offices = $this->convertItemValues($response->officeList);
				}
			}
		}
	}

	/**
	 * This function was added to convert our xml based array into a proper
	 * php array for use in admin search forms.
	 * @param unknown_type $from
	 */
	private function convertItemValues($fromValue) {
		if(iHomefinderDisplayRules::getInstance()->hasItemInSearchFormData()) {
			$result = array();
			foreach($fromValue->item as $element) {
				$result[] = $element;
			}
		} else {
			$result = $fromValue;
		}
		return $result;
	}
	
	public function getHotSheets() {
		$this->initialize();
		return $this->hotSheets;
	}
	
	public function getCities() {
		$this->initialize();
		return $this->cities;
	}
	
	public function getCityZips() {
		$this->initialize();
		return $this->cityZips;
	}
	
	public function getPropertyTypes() {
		$this->initialize();
		return $this->propertyTypes;
	}
	
	public function getAgents() {
		$this->initialize();
		return $this->agents;
	}
	
	public function getOffices() {
		$this->initialize();
		return $this->offices;
	}
	
}